#include "config.h"


#include <string.h>
#include <stdlib.h>
#include <regex.h>
#include <stdio.h>
#include <ctype.h>
#include <assert.h>
#include <err.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include "myglob.h"


myglob::myglob(const char *pattern)
{
    /* Build the regular expression from the pattern */
    char buf[1024];			// should be big enough
    memset(buf,0,sizeof(buf));
    strcpy(buf,"^");
    char b2[2];
    for(const char *cc=pattern;*cc;cc++){
	switch(*cc){
	case '?':
	    strcat(buf,".");
	    break;
	case '.':
	    strcat(buf,"[.]");
	    break;
	case '(':
	    strcat(buf,"\\(");
	    break;
	case ')':
	    strcat(buf,"\\)");
	    break;
	case '*':
	    strcat(buf,".*");
	    break;
	default:
	    b2[0] = *cc;
	    b2[1] = 0;
	    strcat(buf,b2);
	}
    }
    strcat(buf,"$");
    if(regcomp(&reg,buf,REG_EXTENDED|REG_ICASE)) err(1,"regcomp");
}

myglob::~myglob()
{
    regfree(&reg);
}

bool myglob::match(const char *fname)
{
    regmatch_t pmatch[10];
    memset(pmatch,0,sizeof(pmatch));
    int res = regexec(&reg,fname,10,pmatch,0);
    return (res==0);
}


