/*
 * Simson's XML output class.
 */

#include <string>
#include <stdio.h>
#include "tagset.h"

using namespace std;

class xml {
    string outfile;
    FILE *temp;
    tagset tags;
    tagset file_tags;
    void write_dtd(FILE *out);

public:
    static string xmlescape(const string &xml);
    static string xmlstrip(const string &xml);
    xml();
    FILE *file(){return temp;}
    void setoutfile(string outfile);
    void write();			// writes the output to the file
    void xmlout(const string &tag,const string &value,const string &attribute);
    void push(const string &tag,const string &attribute);
    void push(const string &tag) {push(tag,"");fputc('\n',temp);}
    void puts(const string &pdata);	// writes a string as parsed data
    void printf(const char *fmt,...);	// writes a string as parsed data
    void pop(const string &tag);	// close the tag
};
